#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<string.h>
#include"struct.h"


int main(void)
{
	int sockfd;
	unsigned char send_buff[BSIZE]; // buffer for sending packet
	unsigned char recv_buff[BSIZE]; // buffer for receiving packet
	int i; 
	char *ptr;
	int rbyte = 0; // Count received byte
	struct sockaddr_in server;
	int f_code;
	
	// Data structures
	struct mbus_head head;		// Modbus/TCP header
	struct mbus_03_q mbus_03_q;	// Query of Read Multiple Registers
	struct mbus_03_r mbus_03_r;	// Response of Read Multiple Registers
	struct mbus_03_e mbus_03_e;	// Exception of Read Multiple Registers
	struct mbus_10_q mbus_10_q;	// Query of Wirte Multiple Registers
	struct mbus_10_r mbus_10_r;	// Response of Wirte Multiple Registers
	struct mbus_10_e mbus_10_e;	// Exception of Wirte Multiple Registers

	// variables for switching byte orders
	unsigned char h_length, h_word_cnt, h_ref_num, h_reg_val;
	
	in_port_t server_port = 502;
	memset(&server, 0, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons(server_port);
	server.sin_addr.s_addr = inet_addr("192.168.20.10");

	
	if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1){
		perror("fail to call socket()\n");
		exit(1);
	}

	if(connect(sockfd, (struct sockaddr *)&server, SIZE) == -1){
		perror("fail to call connect()\n");
		exit(1);
	}

	while(1)
	{
		printf("Select a Function Code!(Quit: 'Ctrl+C')\n");
		printf("1. [FC 0x03] Read Multiple Register!(INPUT)\n");
		printf("2. [FC 0x10] Write Multiple Register!\n");
		printf("3. [FC 0x03] Read Multiple Register!(OUTPUT)\n");
		scanf("%d", &f_code);
		switch(f_code)
		{
			// Forming data for sending a Read Multiple Register packet for Input ports
			case 1:
				mbus_03_q.head.tranjaction_id 	= 0x00;
				mbus_03_q.head.protocol_id		= 0x00;
				h_length						= 0x06;
				mbus_03_q.head.length			= htons(h_length); 
				mbus_03_q.head.unit_id			= 0x01;
				mbus_03_q.head.fc				= 0x03;
				mbus_03_q.ref_num				= 0x00;
				h_word_cnt						= 0x01;
				mbus_03_q.word_cnt				= htons(h_word_cnt); 
				memcpy(send_buff, &mbus_03_q, sizeof(struct mbus_03_q));
				send(sockfd, send_buff, sizeof(mbus_03_q), 0);
				break;
			// Forming data for sending a Write Multiple Regster packet for Output ports
			case 2:
				mbus_10_q.head.tranjaction_id 	= 0x00;
				mbus_10_q.head.protocol_id		= 0x00;
				h_length 						= 0x09;	
				mbus_10_q.head.length			= htons(h_length);
				mbus_10_q.head.unit_id			= 0x01;
				mbus_10_q.head.fc				= 0x10;
				h_ref_num						= 0x08;	
				mbus_10_q.ref_num				= htons(h_ref_num);
				h_word_cnt						= 0x01;	
				mbus_10_q.word_cnt				= htons(h_word_cnt);
				mbus_10_q.byte_cnt				= 0x02;
				mbus_10_q.reg_val1				= 0x00;
				printf("Enter a Register Value(0~255): ");
				//
				// Input Register Values
				//
				// Input Values (Decimal) : Ports' Status (Binary)
				// 1	: 10000000
				// 2	: 01000000
				// 3	: 11000000
				// 4	: 00100000
				//      ~~~
				// 254	: 01111111
				// 255	: 11111111
				//
				scanf("%d", (int*)&mbus_10_q.reg_val2);
				memcpy(send_buff, &mbus_10_q, sizeof(struct mbus_10_q));
				send(sockfd, &mbus_10_q, sizeof(struct mbus_10_q)-1, 0);
				break;
			// Forming data for sending a Read Multiple Register packet for Output ports
			case 3:
				mbus_03_q.head.tranjaction_id 	= 0x00;
				mbus_03_q.head.protocol_id		= 0x00;
				h_length						= 0x06;
				mbus_03_q.head.length			= htons(h_length); 
				mbus_03_q.head.unit_id			= 0x01;
				mbus_03_q.head.fc				= 0x03;
				h_ref_num						= 0x08;
				mbus_03_q.ref_num				= htons(h_ref_num);
				h_word_cnt						= 0x01;
				mbus_03_q.word_cnt				= htons(h_word_cnt); 
				memcpy(send_buff, &mbus_03_q, sizeof(struct mbus_03_q));
				send(sockfd, send_buff, sizeof(mbus_03_q), 0);
				break;
			default:
				printf("wrong code!!\n");
				exit(1);
		}
		// Receiving Modbus/TCP responses
		rbyte = recv(sockfd, recv_buff, sizeof(recv_buff), 0);
		if(rbyte == -1)
		{
			perror("fail to receive data!");
			exit(1);
		}
		else if(rbyte == 0)
		{
			printf("server has been orderly shutdown!");
			exit(1);
		}
		else{
			ptr = recv_buff;
			memcpy(&head, ptr, sizeof(struct mbus_head));
			f_code = head.fc;
			// Processes of received data
			switch(f_code){
				case fc_r3:
					memcpy(&mbus_03_r, ptr, sizeof(struct mbus_03_r)); 
					if(htons(mbus_03_r.head.length) == 0x05){
						printf("Query has been Succedded!\n");
					}
					// Printing values in binary format
					unsigned char read_val = mbus_03_r.reg_val2;
					char buf[8]={0,0,0,0,0,0,0,0};
					
					for(i = 0; i < 8; i++){
						buf[i] = read_val % 2;
						read_val = read_val / 2;
					}
					printf("Status of Digital I/O ports(0: off, 1: on)\n");
					printf("Port #: 0 1 2 3 4 5 6 7\n");
					printf("Status: ");
					for(i = 0; i < 8; i++){
						printf("%d ", buf[i]);
					}
					break;
				case fc_w10:
					memcpy(&mbus_10_r, ptr, sizeof(struct mbus_10_r)); 
					if(htons(mbus_10_r.head.length) == 0x06){
						printf("Query has been Succedded!\n");
					}
					break;
				case fc_r3_e:
					memcpy(&mbus_03_e, ptr, sizeof(struct mbus_03_e)); 
					if(mbus_03_e.exc_code == 0x01){
						printf("Illegal Function\n");
					}
					else if(mbus_03_e.exc_code == 0x02){
						printf("Illegal Data Address\n");
					}
					else
						printf("Unknown Error!!\n");
					break;
				case fc_w10_e:
					memcpy(&mbus_10_e, ptr, sizeof(struct mbus_10_e)); 
					if(mbus_10_e.exc_code == 0x01){
						printf("Illegal Function\n");
					}
					else if(mbus_10_e.exc_code == 0x02){
						printf("Illegal Data Address\n");
					}
					else
						printf("Unknown Error!!\n");
					break;
				default :
					printf("Unknow Error!!\n");
					break;
			}
		
		}
		printf("\n------------------------------------------------\n");
	
	} // end of loop()
	return 0;

} // end of main()
