#define SIZE		sizeof(struct sockaddr_in)
#define BSIZE		1024

#define fc_r3		0x03
#define fc_w10		0x10
#define fc_r3_e		0x83
#define fc_w10_e	0x90

struct mbus_head					// 8 bytes
{
	unsigned short tranjaction_id;	// 2
	unsigned short protocol_id;		// 2+2=4
	unsigned short length;			// 4+2=6
	unsigned char unit_id;			// 6+1=7
	unsigned char fc;				// 7+1=8	
};

struct mbus_03_q					// 12 bytes
{
	struct mbus_head head;			// 8
	unsigned short ref_num;			// 8+2=10
	unsigned short word_cnt;		// 10+2=12
};

struct mbus_03_r					// 11 bytes
{
	struct mbus_head head;			// 8
	unsigned char byte_cnt;			// 8+1=9
	unsigned char reg_val1;			// 9+1=10
	unsigned char reg_val2;			// 10+1=11
};

struct mbus_03_e					// 9 bytes
{
	struct mbus_head head;			// 8
	unsigned char exc_code;			// 8+1=9
};

struct mbus_10_q					// 15 bytes
{
	struct mbus_head head;			// 8
	unsigned short ref_num;			// 8+2=10
	unsigned short word_cnt;		// 10+2=12
	unsigned char byte_cnt;			// 12+1=13
	unsigned char reg_val1;			// 13+1=14
	unsigned char reg_val2;			// 14+1=15
};

struct mbus_10_r					// 12 bytes
{
	struct mbus_head head;			// 8
	unsigned short ref_num;			// 8+2=10
	unsigned short word_cnt;		// 10+2=12
};

struct mbus_10_e					// 9 bytes
{
	struct mbus_head head;			// 8
	unsigned char exc_code;			// 8+1=9
};


